/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.tarifas;

import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.VigenciaTarifa;
import com.rjconsultores.ventaboletos.service.MarcaService;
import com.rjconsultores.ventaboletos.service.TarifaService;
import com.rjconsultores.ventaboletos.service.VigenciaTarifaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Combobox;

/**
 *
 * @author Rafius
 */
@Controller("generarTarifaController")
@Scope("prototype")
public class GenerarTarifaController extends MyGenericForwardComposer {

    @Autowired
    private MarcaService marcaService;
    @Autowired
    private VigenciaTarifaService vigenciaTarifaService;
    @Autowired
    private TarifaService tarifaService;
    private List<VigenciaTarifa> lsVigenciaTarifa;
    private List<Marca> lsMarca;
    private Combobox cmbVigencia;
    private Combobox cmbMarca;
    private static Logger log = Logger.getLogger(GenerarTarifaController.class);

    public Combobox getCmbVigencia() {
        return cmbVigencia;
    }

    public void setCmbVigencia(Combobox cmbVigencia) {
        this.cmbVigencia = cmbVigencia;
    }

    public List<VigenciaTarifa> getLsVigenciaTarifa() {
        return lsVigenciaTarifa;
    }

    public void setLsVigenciaTarifa(List<VigenciaTarifa> lsVigenciaTarifa) {
        this.lsVigenciaTarifa = lsVigenciaTarifa;
    }

    public List<Marca> getLsMarca() {
        return lsMarca;
    }

    public void setLsMarca(List<Marca> lsMarca) {
        this.lsMarca = lsMarca;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsVigenciaTarifa = vigenciaTarifaService.obtenerTodos();
        lsMarca = marcaService.buscarTodosExceto(UsuarioLogado.getUsuarioLogado(),-1);
        
        super.doAfterCompose(comp);
    }

    public void onClick$btnCambiarVigencia(Event ev) {
        cmbVigencia.getValue();
        cmbMarca.getValue();

        try {
            VigenciaTarifa vigencia = (VigenciaTarifa) (cmbVigencia.getSelectedItem() != null ? cmbVigencia.getSelectedItem().getValue() : null);
            Marca marca = (Marca) (cmbMarca.getSelectedItem() != null ? cmbMarca.getSelectedItem().getValue() : null);

            Boolean gerou = tarifaService.generarTarifas(vigencia, marca);

            if (gerou) {
                Messagebox.show("Generación se registró exitosamente",
                        Labels.getLabel("generarTarifaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } else {
                Messagebox.show(
                        Labels.getLabel("MSG.Error"),
                        Labels.getLabel("generarTarifaController.window.title"),
                        Messagebox.OK, Messagebox.ERROR);
            }
            closeWindow();
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
